<?php

namespace Unific\Extension\Helper\Data;

use Magento\Framework\Exception\InputException;
use Symfony\Component\Config\Definition\Exception\Exception;

class AdminUser extends AbstractData
{
    // Holds a ADMIN USER API DATA object
    protected $user;

    protected $returnData = array();

    /**
     * OrderPlugin constructor.
     * @param \Magento\Framework\App\Helper\Context $context
     * @param \Unific\Extension\Logger\Logger $logger
     * @param \Unific\Extension\Helper\Filter $filterHelper
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Unific\Extension\Logger\Logger $logger,
        \Unific\Extension\Helper\Filter $filterHelper
    )
    {
        parent::__construct($context, $logger, $filterHelper);
    }

    /**
     * @param \Magento\User\Api\Data\UserInterface $user
     */
    public function setUser(\Magento\User\Api\Data\UserInterface $user)
    {
        $this->user = $user;
        $this->setUserInfo();
    }

    /**
     * @return \Magento\User\Api\Data\UserInterface
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * @return void
     */
    protected function setUserInfo()
    {
        $this->returnData = $this->user->getData();
    }

    /**
     * @return array
     */
    public function getUserInfo()
    {
        return array_intersect_key($this->returnData, array_flip($this->filterHelper->getAdminUserWhitelist()));
    }
}
